  !   XML    
  !    https://forum.clarionlife.net/

  Program
  Include('tXML.inc'),Once
  Map
  end

Loc:MyXML    Class(ToyXML).       !  ToyXML -    CpXML

Loc:FileXML  CString('test.xml')  !    XML   ( )
!Loc:FileXML  CString('pros.xml') !    XML   ()
!Loc:FileXML  CString('mark.xml') !    XML   ( - )

Loc:EDO      Group                !  
File           Group(EDO::G_File),      Name('').
             end

Loc:QSigned  Queue                ! 
Podpisant      Group(EDO::G_Podpisant), Name('').
             end

Loc:QTab     Queue                !     ()
SvedTov        Group(EDO::G_SvedTov),   Name('').
             end

Loc:QInfo2   Queue                !     
TextInf        Group(EDO::G_TextInfTip),Name('2')
NumRow           Long,Name('')  !       EDO::G_SvedTov
               end
             end

Loc:QSv      Queue                !    
TD             Group(EDO::G_SvTD),Name('')
NumRow           Long,Name('')  !       EDO::G_SvedTov
               end
             end

Loc:QProsl   Queue                ! 
SvedProsl      Group(EDO::G_TrackGoods),Name('')
NumRow           Long,Name('')  !       EDO::G_SvedTov
               end
             end

Loc:QIdTov   Queue                !    ( - )
NomerSred      Group(EDO::G_NumIdGoods),Name('')
NumRow           Long,Name('')  !       EDO::G_SvedTov
               end
             end

Loc:NDoc     CString(255)         !     
Loc:NOsnova  CString(255)
Loc:NSeller  CString(255)
Loc:NCustom  CString(255)
Loc:SCod     CString( 15)
Loc:IdEDO1   CString( 47)
Loc:IdEDO2   CString( 47)

Write        Class(PushXML).

  Code
  Locale('CLACHARSET','WINDOWS')  !   (    Lower() / Upper())
  Locale('CLACOLSEQ','WINDOWS')
  Locale('CLACASE','WINDOWS')

  System{Prop:CharSet}     = Charset:Cyrillic
  System{Prop:FontCharSet} = Charset:Cyrillic
  System{Prop:FontSize}    = 11
  System{Prop:FontCharSet + Prop:TipsFont} = Charset:Cyrillic
  System{Prop:FontSize    + Prop:TipsFont} = 11

  Loc:MyXML.DebugMode = True   !    

  !  XML DOM     Windows-1251
  If Not Loc:MyXML.Init(3,Loc:FileXML) then Message('   XML  !','  ',Icon:Exclamation,'&1. ')
  else
     ! ---  

     Loc:MyXML.SetRule('',  'Ignore',True)  !    (     )
     Loc:MyXML.SetRule('','Ignore',True)

     If Loc:MyXML.ToGroup(Loc:EDO,'') = False  !    
        Message('      !','  ',Icon:Exclamation,'&1. ')

     elsIf (Loc:EDO.File.Document.KND <> '1115131') Or (InList(Upper(Loc:EDO.File.Document.Func),'','','') = 0)
        Message('  XML      !','  ',Icon:Exclamation,'&1. ')

     else
        Loc:NDoc    = ' '   & Choose(Loc:EDO.File.Document.SvSchFact.NumberSF = '','/',Loc:EDO.File.Document.SvSchFact.NumberSF) & |
                      '  ' & Loc:EDO.File.Document.SvSchFact.DateSF & ' .   ' & |
                      Clip(Left(Format(Loc:EDO.File.Document.TableSF.TotalPaid.CostAll,@n_13.2))) & ' .'

        Loc:NOsnova = ' '    & Loc:EDO.File.Document.SvProdPer.SvPer.OsnPer.NumOsn  & |
                      '  '  & Loc:EDO.File.Document.SvProdPer.SvPer.OsnPer.DateOsn & |
                      ' .: ' & Loc:EDO.File.Document.SvProdPer.SvPer.OsnPer.Name
                                                      
        ! 
        If Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvUL.InnUL <> ''     ! 
           Loc:NSeller = ': ' & Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvUL.InnUL & ', ' & Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvUL.Name

        elsIf Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvIP.InnFL <> ''  ! 
           Loc:NSeller = ': ' & Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvIP.InnFL    & ', ' & |
           Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvIP.FIO.Fam  & ' ' & |
           Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvIP.FIO.Name & ' ' & |
           Loc:EDO.File.Document.SvSchFact.SvProd.IdSv.SvIP.FIO.Otch
        else Loc:NSeller = ' '.                                    !  (  ?)

        ! 
        If Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvUL.InnUL <> ''    ! 
           Loc:NCustom = ': ' & Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvUL.InnUL & ', ' & Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvUL.Name

        elsIf Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvIP.InnFL <> '' ! 
           Loc:NCustom = ': ' & Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvIP.InnFL    & ', ' & |
           Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvIP.FIO.Fam  & ' ' & |
           Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvIP.FIO.Name & ' ' & |
           Loc:EDO.File.Document.SvSchFact.SvPokup.IdSv.SvIP.FIO.Otch
        else Loc:NCustom = ' '.                                    !  (  ?)

        ! ---   FreeRules()

        !    XML     
        FlagRegion# = Loc:MyXML.SpecifiedTag(Loc:EDO.File.Document.SvSchFact.SvProd.Address.AdrRF.Region)  ! 
        FlagCity#   = Loc:MyXML.SpecifiedTag(Loc:EDO.File.Document.SvSchFact.SvProd.Address.AdrRF.City)    ! 

        !     
        RegionProd" = Loc:MyXML.ValueByName('//////')
        Loc:IdEDO1  = Loc:MyXML.ValueByName('//')
        Loc:IdEDO2  = Loc:MyXML.ValueByName('//')

        !      
        GruzPolu"   = Loc:MyXML.ValueByGroup(Loc:EDO.File.Document.SvSchFact.GruzPol,'//')

        Loc:MyXML.FreeRules()  !    (  - ..    )

        !      
        Loc:MyXML.ToQueue(Loc:QSigned,'')
        Get(Loc:QSigned,1); PP1" = TXM::PodpisEdo(Loc:QSigned.Podpisant)
        Get(Loc:QSigned,2); PP2" = TXM::PodpisEdo(Loc:QSigned.Podpisant,True)

        Message(': '        & Loc:NDoc    & '|: ' & Loc:NOsnova & |
              '||: '        & Loc:NSeller & '|ID : '    & Loc:IdEDO1  & |
              '||: '      & Loc:NCustom & '|ID : '    & Loc:IdEDO2  & |
              '||: '      & Records(Loc:QSigned)                       & |
              '|: '           & PP1"                                       & |
              '|: '           & PP2"                                       & |
              '||   XML |' & All('- ',60)                    & |
               '| : ' & Choose(FlagRegion# = True,'','')    & |
               '|  : ' & Choose(FlagCity#   = True,'','')    & |
              '|| : ' & RegionProd"                                & |
               '|: ' & GruzPolu"                                    |
              ,'')

        !       SetRule([   ],'IsList',[  ],[ QUEUE])
        Loc:MyXML.SetRule('2',                'IsList','',Loc:QInfo2)  !            (:  )
        Loc:MyXML.SetRule('',                      'IsList','',Loc:QSv)     !    
        Loc:MyXML.SetRule('/',    'IsList','',Loc:QProsl)  !   (  Self.TagSeparator   !)
        Loc:MyXML.SetRule('/','IsList','',Loc:QIdTov)  !   

        Loc:MyXML.ToQueue(Loc:QTab,'')  !     +     SetRule(..'IsList'..)
        Loc:MyXML.FreeRules()                  !   

        If Records(Loc:QTab) = 0
           Message('       !','  ',Icon:Exclamation,'&1. ')
        else
           !  
           Message('-   = ' & Records(Loc:QTab))
           Loop Count# = 1 to Records(Loc:QTab)
             Get(Loc:QTab,Count#)

             Clear(Loc:SCod)  !  - 

             ! 1.    
             If (Sub(Loc:QTab.SvedTov.AddInfoGoods.NumIdGoods.NumberPack,01,02) = '02') and |
                (Sub(Loc:QTab.SvedTov.AddInfoGoods.NumIdGoods.NumberPack,17,02) = '37') and |
                Numeric(Sub(Loc:QTab.SvedTov.AddInfoGoods.NumIdGoods.NumberPack,03,14))

                Loc:SCod = Sub(Loc:QTab.SvedTov.AddInfoGoods.NumIdGoods.NumberPack,03,14)
             end

             ! 2.  
             If Loc:SCod = '' and Loc:QTab.SvedTov.AddInfoGoods.CodTov <> '' and Numeric(Loc:QTab.SvedTov.AddInfoGoods.CodTov)
                Loc:SCod = Loc:QTab.SvedTov.AddInfoGoods.CodTov
             end

             ! 3. GTIN
             If Loc:SCod = '' and Records(Loc:QInfo2) > 0
                Clear(Loc:QInfo2)
                Loc:QInfo2.TextInf.NumRow = Loc:QTab.SvedTov.NumRow
                Get(Loc:QInfo2,Loc:QInfo2.TextInf.NumRow)
                If ~ErrorCode() and (Upper(Loc:QInfo2.TextInf.Id) = 'GTIN') and (Loc:QInfo2.TextInf.Value <> '') and Numeric(Loc:QInfo2.TextInf.Value)
                   Loc:SCod = Loc:QInfo2.TextInf.Value
                end
             end

             Message('  = ' & Loc:QTab.SvedTov.NumRow  & |
                     '| = '     & Loc:QTab.SvedTov.Name    & |
                     '|- = '   & Loc:SCod                 & |
                    '||  = '     & Loc:QTab.SvedTov.Kolvo   & |
                     '| = '          & Loc:QTab.SvedTov.AddInfoGoods.UnitName & |
                     '| = '        & Loc:QTab.SvedTov.Price   & |
                     '| = '  & Loc:QTab.SvedTov.Cost    & |
                     '| = '     & Loc:QTab.SvedTov.AddInfoGoods.CodTov,' ')
           end

           If Records(Loc:QInfo2) > 0
              Message('-   = ' & Records(Loc:QInfo2))
              Loop Count# = 1 to Records(Loc:QInfo2)
                Get(Loc:QInfo2,Count#)
                Message('  = ' & Loc:QInfo2.TextInf.NumRow  & | !   
                       '|  = '     & Loc:QInfo2.TextInf.Id      & | ! 
                       '| = '     & Loc:QInfo2.TextInf.Value,' ')
              end
           end

           If Records(Loc:QSv) > 0
              Message('    = ' & Records(Loc:QSv))
              Loop Count# = 1 to Records(Loc:QSv)
                Get(Loc:QSv,Count#)
                Message('  = ' & Loc:QSv.TD.NumRow          & | !   
                       '| = '    & Loc:QSv.TD.CodeCountry     & | !      ( 10 -)
                       '| = '      & Loc:QSv.TD.RegNumTD,' ')
              end
           end

           If Records(Loc:QProsl) > 0
              Message('-   = ' & Records(Loc:QProsl))
              Loop Count# = 1 to Records(Loc:QProsl)
                Get(Loc:QProsl,Count#)
                Message('  = '      & Loc:QProsl.SvedProsl.NumRow         & | !   
                       '| = '     & Loc:QProsl.SvedProsl.RegNumTrack    & | !    
                       '| = '      & Loc:QProsl.SvedProsl.UnitTrack      & | !    
                       '| = '     & Loc:QProsl.SvedProsl.KolvoTrack     & | !       
                       '| = '  & Loc:QProsl.SvedProsl.NameUnitTrack,   | !     
                        '')
              end
           end

          If Records(Loc:QIdTov) > 0
              Message('   () = ' & Records(Loc:QIdTov))
              Loop Count# = 1 to Records(Loc:QIdTov)
                Get(Loc:QIdTov,Count#)
                Message('  = '      & Loc:QIdTov.NomerSred.NumRow         & | !   
                       '| = '    & Loc:QIdTov.NomerSred.IdTransPack    & | !    
                       '| = '               & Loc:QIdTov.NomerSred.KIZ            & | !   
                       '| = '           & Loc:QIdTov.NomerSred.NumberPack,      | !    () 
                        ' ()')
              end
          end

        end
     end

     Loc:MyXML.Kill  !  (     )
  end

  ! ---  XML 

  If Write.Init(True)         !  UTF-8 
     Write.AddCap             !  
                              ! 
     Write.AddRem(' PushXML -     !')

     If Write.Opened('Root')  !    
                              !    
        Write.SetAtr('1',' ')
        Write.SetAtr('2',' ')
        Write.Closed('1')
                              !    
        Write.SetAtr('3',' ')
        If Write.Opened('1')
                              !      
           Write.SetAtr('4',    ' ')
           Write.Closed('2',' ')
                              !   
           Write.EndTag('1')
        end
                              !     BASE64
        Write.AddFile('','test.xml')
                              !   
        Write.AddStr('<?mso-application progid="Excel.Sheet"?>')
                              !   CDATA
        Write.AddCData('FreeText',' <<> & ')

        Write.EndTag('Root')  !   
     end

     Write.SaveAs('TestPush.xml')
     Write.Kill
  end